﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Topics.Radical.ComponentModel;
using Topics.Radical.Linq;
using Topics.Radical.Windows.Presentation.Boot;

namespace Topics.Radical.Windows.Presentation.Puzzle.Boot.Installers
{
    public class PresentationDescriptor : IPuzzleSetupDescriptor
    {
        #region IPuzzleSetupDescriptor

        public void Setup(IPuzzleContainer container, Func<IEnumerable<Type>> knownTypesProvider)
        {
            var conventions = container.Resolve<BootstrapConventions>();
            var allTypes = knownTypesProvider();

            allTypes.Where(t => conventions.IsViewModel(t) && !conventions.IsExcluded(t))
                .Select(t => new
                {
                    Contracts = conventions.SelectViewModelContracts(t),
                    Implementation = t,
                    Lifestyle = conventions.IsShellViewModel(conventions.SelectViewModelContracts(t), t) ?
                        Lifestyle.Singleton :
                        Lifestyle.Transient
                })
                .ForEach(descriptor =>
                {
                    container.Register(
                        EntryBuilder.For(descriptor.Contracts.First())
                            .ImplementedBy(descriptor.Implementation)
                            .WithLifestyle(descriptor.Lifestyle)
                    );
                });

            //allTypes.Where(t => conventions.IsView(t) && !conventions.IsExcluded(t))
            //    .Select(t => new
            //    {
            //        Contracts = conventions.SelectViewContracts(t),
            //        Implementation = t,
            //        Lifestyle = conventions.IsShellView(conventions.SelectViewModelContracts(t), t) ?
            //            Lifestyle.Singleton :
            //            Lifestyle.Transient
            //    })
            //    .ForEach(descriptor =>
            //    {
            //        container.Register(
            //            EntryBuilder.For(descriptor.Contracts.First())
            //                .ImplementedBy(descriptor.Implementation)
            //                .WithLifestyle(descriptor.Lifestyle)
            //        );
            //    });
        }

        #endregion
    }
}
