﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Topics.Radical.ComponentModel;
using Topics.Radical.Linq;
using Topics.Radical.Windows.Presentation.Boot;

namespace Topics.Radical.Windows.Presentation.Puzzle.Boot.Installers
{
    public class ServicesDescriptor : IPuzzleSetupDescriptor
    {
        #region IPuzzleSetupDescriptor
        
        public void Setup(IPuzzleContainer container, Func<IEnumerable<Type>> knownTypesProvider)
        {
            var conventions = container.Resolve<BootstrapConventions>();

            knownTypesProvider()
                .Where(t => conventions.IsService(t) && !conventions.IsExcluded(t))
                .Select(t => new
                {
                    Contracts = conventions.SelectServiceContracts(t),
                    Implementation = t
                })
                .ForEach(descriptor =>
                {
                    container.Register(
                        EntryBuilder.For(descriptor.Contracts.First())
                            .ImplementedBy(descriptor.Implementation)
                            //.Overridable()
                    );
                });
        }

        #endregion
    }
}
