﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Topics.Radical.ComponentModel;
using Topics.Radical.Windows.Presentation.Boot;

namespace Topics.Radical.Windows.Presentation.Boot
{
    public class PuzzleApplicationBootstrapper : ApplicationBootstrapper
    {
        IPuzzleContainer container;
        //NavigationHost host;

        public IEnumerable<IPuzzleSetupDescriptor> Installers { get; set; }

        protected PuzzleApplicationBootstrapper()
        {
            //this.UsingAsNavigationHost(new WindowNavigationHost(Window.Current));
        }

        protected override IServiceProvider CreateServiceProvider()
        {
            this.container = new PuzzleContainer();
            var facade = new PuzzleContainerServiceProviderFacade(this.container);

            this.container.Register(EntryBuilder.For<ApplicationBootstrapper>()
                .UsingInstance(this));
            this.container.Register(EntryBuilder.For<IPuzzleContainer>()
                .UsingInstance(this.container));
            this.container.Register(EntryBuilder.For<IServiceProvider>()
                .UsingInstance(facade));
            this.container.Register(EntryBuilder.For<Boot.BootstrapConventions>()
                .UsingInstance(new Boot.BootstrapConventions()));

            //var view = CoreApplication.GetCurrentView();
            //var dispatcher = view.CoreWindow.Dispatcher;

            //this.container.Register(
            //        EntryBuilder.For<CoreDispatcher>()
            //            .UsingInstance(dispatcher)
            //);

            //this.container.AddFacility<SubscribeToMessageFacility>();

            return facade;
        }

        protected virtual Boolean ShouldInstall(IPuzzleSetupDescriptor installer)
        {
            return true;
        }
    }
}
